var Favorites = {
	items: new Array(),
	itemsw: new Array(),
	itemsv: new Array(), // элементы, которые соответствуют выбранным фильтрам (нужны для правильного подсчета страниц)
	isVisible: false,
	xmlHTTPFav : null,
	isDell: false,
	fvCurrentCategory: -1, // -1 - все категории
	fvCurrentSection: 0,
};

var FavoritesSections = [
	"Все избранное",
	"Избранное (ТВ)",
	"Избранное (Сайт)",
	"На будущее (Сайт)",
];

Favorites.open = function() {
	Favorites.isVisible = true;
	Favorites.items = new Array();
	Main.setResSimple();
	Main.page = 0;
	
	if (Main.isLogin){
		switch (Favorites.fvCurrentSection) {
			case 0:
				Favorites.read();
				Favorites.getFavFromSite('favorites');
				Favorites.getFavFromSite('forlater');
				break;
			case 1:
				Favorites.read();
				Favorites.showItems();
				break;
			case 2:
				Favorites.getFavFromSite('favorites');
				break;
			case 3:
				Favorites.getFavFromSite('forlater');
				break;
		}
	} else {
		Favorites.fvCurrentSection = 1;
		Favorites.read();
		Favorites.showItems();
	}
	
	Favorites.changeFilter();
};

Favorites.read = function() {
	Favorites.items = new Array();
	var fileSystemObj = new FileSystem();
	var fileObj = fileSystemObj.openCommonFile(curWidget.id+'/fs_fav.data','r');
	if (fileObj){
		var strResult = fileObj.readAll();
		if (strResult){
			Favorites.items = JSON.parse(strResult);
		}
		fileSystemObj.closeCommonFile(fileObj);
	}
};

Favorites.write = function() {
	var fileSystemObj = new FileSystem();
	if (!fileSystemObj.isValidCommonPath(curWidget.id)) fileSystemObj.createCommonDir(curWidget.id);
    var fileObj = fileSystemObj.openCommonFile(curWidget.id+'/fs_fav.data','w');
    if (fileObj)
    {
		Favorites.itemsw = new Array();
				
		$.each(this.items, function(index, item) {			
			if (item.type !='fs'){
				Favorites.itemsw[Favorites.itemsw.length] = item;				
			}
		});
		
		var str = JSON.stringify(Favorites.itemsw);
		fileObj.writeAll(str);
		fileSystemObj.closeCommonFile(fileObj);
    }
};

Favorites.getFavFromSite = function(section) {
	$.ajax({
		url: 'http://brb.to/myfavourites.aspx?page=' + section,
		async: true, // только true, иначе не будут работать кросдоменные запросы на F серии
		dataType: 'html',
		beforeSend: function() {
			Main.showLoading();
		},	
		success: function(sOut) {
			//alert (sOut);
			var $sOut = $($.parseHTML(sOut));
			
			$sOut.find('.b-poster-thin__wrapper').each(function(){
				var obj = new Object();
				
				obj.url = Main.prefixURL + $(this).find('.b-poster-thin').attr('href');
				obj.img = $(this).find('.b-poster-thin').css('background-image').replace('url(','').replace(')','').replace('\'','').replace(/\/13\/([0-9]+)\.jpg/g, '\/6\/$1.jpg');
				obj.name = $(this).find('.b-poster-thin span').html().replace(/<p>.*<p>/g, " ").replace(/<\/p>/g, "");
				
				var rel = $(this).find('.b-poster-thin__link-delete').attr('rel');
				rel = rel.match("actionName: '(.*)'");
				
				obj.urld = Main.prefixURL + rel[1];
				obj.type = 'fs';
				obj.section = section;
	
				Favorites.items[Favorites.items.length] = obj;
			});
			
			Favorites.showItems();
			Main.hideLoading();
		}
	});
};

Favorites.showItems = function() {
	Main.clearBlocks();
	
	Favorites.itemsv = new Array();
	
	$.each(Favorites.items, function(i, item) {
		if(Favorites.fvCurrentCategory < 0){
			// Если выбраны все разделы, проверяем что бы не было мусора типа игр и т.д.
			$.each(FS_Category_URL, function(j, url) {
				if(item.url.indexOf(url) > -1){
					Favorites.itemsv[Favorites.itemsv.length] = item;
				}
			});
		} else if (item.url.indexOf(FS_Category_URL[Favorites.fvCurrentCategory]) > -1){
			Favorites.itemsv[Favorites.itemsv.length] = item;
		}
	});
	
	if (Favorites.itemsv.length > 0){
		for (var i = Main.page*15; i < Favorites.itemsv.length && i < (Main.page+1)*15; i++){
			if (Favorites.itemsv[i].descr){ delete Favorites.itemsv[i].descr; }
			Favorites.itemsv[i].url = Favorites.itemsv[i].url.replace("?ajax&folder=0","");
			
			URLtoXML.ImgDickr[i+1-Main.page*15] = Favorites.itemsv[i].img;
			URLtoXML.UrlSt[i+1-Main.page*15] = Favorites.itemsv[i].url;
			URLtoXML.sName[i+1-Main.page*15] = Favorites.itemsv[i].name;
			URLtoXML.pDes[i+1-Main.page*15] = '';
			
			var icon = '';
			if (Favorites.itemsv[i].section != undefined) {icon = '<div class="fav_' + Favorites.itemsv[i].section + '"></div>';}
			
			if (URLtoXML.sName[Main.index]){
				$("#title").html(URLtoXML.sName[Main.index]);
			}else{
				$("#title").html('');
			}
			
			$("#bloc" + (i+1-Main.page*15)).html("<img class='blockImage blockImagefav' id='imgst" + (i+1-Main.page*15) +  "'  src='" + URLtoXML.ImgDickr[i+1-Main.page*15] + "' />" + icon);
			$("#imgst" + Main.index).css('border-color','#FF6600'); // активная строка
		}
	}
};

Favorites.add  = function(){
	Favorites.read(); // read favorites from tv
	Favorites.addLine();
};

Favorites.del = function(){
	Favorites.delLine();
};

Favorites.addLine = function() {
	var obj = new Object();
		
	obj.url = URLtoXML.UrlSt[Main.index];
	obj.name = URLtoXML.sName[Main.index];
	obj.img = URLtoXML.ImgDickr[Main.index];
	
	var isAdd = true;
	for(var i=0; i<this.items.length && isAdd; i++){
		if (this.items[i].name == obj.name){
			isAdd = false;
		}
	}

	if (isAdd){
		Favorites.items[Favorites.items.length] = obj;
		Favorites.write();
		Display.statusLine(obj.name + "<br /> добавленно в избранное");
	} else {
		Display.statusLine(obj.name + "<br /> уже присутствует в избранном");
	}
};

Favorites.delLine = function(){
	// get selected item index
	var index = '';
	$.each(Favorites.items, function(i, item) {	
		if (item.url == Favorites.itemsv[Main.index + Main.page*15 - 1].url && item.section == Favorites.itemsv[Main.index + Main.page*15 - 1].section){
			index = i;
		}
	});
	
	if (index !== ''){
		if (Favorites.items[index].type == 'fs'){
			$.ajax({
				type: 'POST',
				url: Favorites.items[index].urld,
				crossDomain: true, 
				async: true
			});
		}

		Display.statusLine(Favorites.items[index].name + "<br /> удалено из избранного");
		
		var d = Main.index + Main.page*15 - 1;
		Main.clearBlocks();
		Favorites.items.splice(index, 1);
		// Перезаписываем избранное только если находимся в разделах "Все избранное" или "Избранное (ТВ)"
		if(Favorites.fvCurrentSection == 0 || Favorites.fvCurrentSection == 1){
			Favorites.write();
		}
		if (Favorites.items.length <= (Main.page*15) && Main.page > 0) Main.page--;
		Favorites.showItems();
		if(Favorites.items.length <= d) d--;
		Main.ActivString(d - Main.page*15); // устанавливаем активный элемент на туже позицию, которая была удалена
	}
};

Favorites.changePage = function() {
	var idx = Main.index;
	Main.clearBlocks();
	Main.index = idx;
	Favorites.showItems();
	
	if (Favorites.itemsv.length > (Main.page*15)){
		return 1;
	}else{
		if (Main.page > 0) Main.page--;
		Favorites.showItems();
		return 0;
	}
};

Favorites.changeFilter = function() {
	Main.page = 0;
	
	var janrText = '';
	
	if(Favorites.fvCurrentCategory < 0){
		janrText = 'Все категории';
	} else {
		janrText = FS_CategoryWords[Favorites.fvCurrentCategory];
	}
	
	$("#breadcrumbs > #level_1 > span").html(FavoritesSections[Favorites.fvCurrentSection]);
	$("#breadcrumbs > #level_2 > span").html(janrText);
	
	Main.saveSettings();
};

Favorites.changeSection = function() {
	if (Favorites.fvCurrentSection < 3){
		Favorites.fvCurrentSection++;
	}else{
		Favorites.fvCurrentSection=0;
	}
	Favorites.open();
	Main.saveSettings();
};